/*******************************************************************************

HERE the other foobar eg: GPL etc.


REMEMBER: first copy to new file, THEN make changes!


***************************************************************************** */
(function autoPrint2(){
	//
	const Cc = Components.classes;
	const Ci = Components.interfaces;
	const Cu = Components.utils;
	//
	this.autoprint2 = {};
	var self = this.autoprint2;
	self.version = '$VER: autoprint.js 2.1.0.2.rc (20110312) (20010214???) Daniel+Frank $';
	// value(false|true) set this to true to become debugout on JS-console 
	self.debug_out=true;
	//
	self.name = autoPrint2;
	//
	self._running=false;
	self._timeout=null;
	self._messageList = [];
	self._messageIDList = [];
	self._silent = function(bState) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		prefs.setBoolPref("print.always_print_silent",bState);
		if(self.debug_out) {Application.console.log("Version: " + self.version + "\n");};
		if(self.debug_out) {Application.console.log("Set prefs.js print.always_print_silent: " + bState + "\n");};
	};
	self._silentOn = function() { self._silent(true);};
	self._silentOff = function() { self._silent(false);};
	self._doPrint = function() {
		
		if(!self._running) {return;};
		if(self.debug_out) {Application.console.log("Searching my mails to print ... ");};
		
		// our list to fill with the URIs
		var messageList = [];
		// alert("messageList.length: " + messageList.length);
		//
		// The code between the markers searches the mails in all MsgFolders
		// this is because the mail could have been moved by a filter...
		// some users got empty pages printed if the message moved
		//-------
		var acctMgr = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
		var accounts = acctMgr.accounts;
		//
		if(self.debug_out) {Application.console.log("self._messageIDList.length: " + self._messageIDList.length);};
		for(var i=0; i < self._messageIDList.length;i++) { // all messages to pring
			for (var j = 0; j < accounts.Count(); j++) { // all accounts
				var account = accounts.QueryElementAt(j, Components.interfaces.nsIMsgAccount);
				var rootFolder = account.incomingServer.rootFolder; // nsIMsgFolder
				var db = null;
				var hdr = null;
				var hdr2 = null;
				var folders = [];
				var MSG = 'Root Folder\n'+rootFolder.prettiestName+": " + rootFolder.numSubFolders;
				if(self.debug_out) {Application.console.log(MSG);};
				if(rootFolder.numSubFolders > 0) {
					try {
						folders.push(rootFolder.subFolders);
						do {
							var subf = folders.pop();
							// alert("subf: " + subf.length);
							while(subf.hasMoreElements()) {
								var fold = subf.getNext();
								fold.QueryInterface(Components.interfaces.nsIMsgFolder);
								if(fold.numSubFolders > 0) {
									folders.push(fold.subFolders);
								}
								db = fold.msgDatabase;
								if(db) {
									var T_OUT = '';
									hdr = db.getMsgHdrForMessageID(self._messageIDList[i]);   //methode 1
									// if(self.debug_out) {Application.console.log("DB in Folder: "+fold.prettiestName + "\n");};
									if(hdr) {
										if(self.debug_out) {Application.console.log("MAIL FOUND!\nSubject: "+hdr.mime2DecodedSubject);};
										break;
									}
								}
							}
						} while((hdr == null) && (folders.length > 0));
					}catch(e) {
						var EX_MSG="Oh Oh, Exception caught.. Please check the summary-files (*.msf). \n"
							+"Even try an search overall like: 'subject contains er' to solve it. \n"
							+"By more questions: http://www.fkn-systems.de/_autoprint \n"
							+"\n"
							+"Fehlerhafte Zusammenfassungsdatei gefunden (*.msf)!\n"
							+"Bitte Rechtsklick auf betreffenden Ordner und Zusammenfassungsdatei neu erstellen.\n"
							+"Starte eine Suche über alle Ordner z.B. 'Betreff enthält er', um das problem zu lösen. \n"
							+"Bei weiteren Fragen: http://www.fkn-systems.de/_autoprint \n"
							+"\n";
		/// Hmmm, wieso geht das nicht??
		// mus man den strin für alert auskommentieen == htmlspecialchar ??
		//					+"Version: " + self.version + "\n");
						if(self.debug_out) {Application.console.log(EX_MSG);};
						alert(EX_MSG);
					}
				}
				if(hdr!=null) {
					messageList.push(hdr.folder.getUriForMsg(hdr));
					break;
				}
			}
		}
		// to hide the dialog
		self._silentOn();
		//--------
		// do the print magic
		if(self.debug_out) {Application.console.log("PD: messageList.length = " + messageList.length);};
		window.openDialog("chrome://messenger/content/msgPrintEngine.xul", "","chrome,dialog=no,all,centerscreen",messageList.length, messageList, statusFeedback,false, Ci.nsIMsgPrintEngine.MNAB_PRINT_MSG, window);
		// when an printer-requester appears between multiprint increment this timer. Standart: '15000' # eq 15sec
		window.setTimeout(autoprint2._silentOff,15000); // switch off silent printing in 15sec
		self._running=false;
		self._messageList = [];
		self._messageIDList = [];
	};
	//
	self._init = function() {
		this._printing = {
			id: "autoprint2@daniel.luttinger.eu#print",
			name: "Print mail",
			apply: function(aMsgHdrs, aActionValue, aListener, aType, aMsgWindow) {
				if(!self._running) {
					self._running=true;
				}else{
					window.clearTimeout(self._timeout);
				}
				//
				var count = aMsgHdrs.length;
				// T_OUT is for collect debug msgs
				var T_OUT = '';
				//
				for (var i = 0; i < count; i++) {
					var hdr = aMsgHdrs.queryElementAt(i, Ci.nsIMsgDBHdr);
					// var uri = hdr.folder.getUriForMsg(hdr);
					self._messageIDList.push(hdr.messageId);
					self._messageList.push(hdr.messageKey);
					T_OUT += "ID: " + hdr.messageId + "\n";
					T_OUT += "MK: " + hdr.messageKey+ "\n";
				}
				// Testout mesgs
				if(self.debug_out) {Application.console.log(T_OUT);};
				//
				// alert("got mail.\nc1:"+count+" == c2:"+self._messageList.length+"?");
				self._timeout=window.setTimeout(autoprint2._doPrint,3000);
			},
			isValidForType: function(type, scope) {return true;},
			validateActionValue: function(value, folder, type) {return null;},
			allowDuplicates: false,needsBody: true
		};
		// here we get the filterservice and add our custom action
		var filterService = Cc["@mozilla.org/messenger/services/filters;1"].getService(Ci.nsIMsgFilterService);
		filterService.addCustomAction(_printing);
		//
		removeEventListener("load",autoprint2._init, true);
	}
})();
//
window.addEventListener("load", autoprint2._init, true);
//
